#include <bits/stdc++.h>

using namespace std;

int main(){
	
	ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    
    int n, h;
    cin>>h>>n;
    int mat[h+1][n+1];
    for(int i=1; i<=n; i++)
    {
    	mat[0][i]=1;
	}
	
	
	
    for(int i=1; i<=h; i++){
    	for(int j=1; j<=n; j++){
    		cin>>mat[i][j];
    				}
    				
    	for(int j=1; j<=n; j++)
		{
			if(mat[i][j]>0){
			
			mat[i][j]+=mat[i-1][j];
			
				}
			else
			{
				int slobd=-1;
				int slobl=-1;
				for(int g=j; g<=n; g++)
				if(mat[i][g]>0)
				{
					slobd=g;
					break;
				}
				for(int g=j; g>0; g--)
				if(mat[i][g]>0)
				{
					slobl=g;
					break;
				}
				if(slobd==-1 && slobl!=-1)
				{
					mat[i][slobl]+=mat[i-1][j];
				}
				else if(slobl==-1 && slobd!=-1)
				{
					mat[i][slobd]+=mat[i-1][j];
				}
			
				else if(mat[i-1][j]%2==1 && slobd!=-1 && slobl!=-1 ){                                     
				
					if(i%2==0){
						mat[i][slobd]+=mat[i-1][j]/2+1;
						mat[i][slobl]+=mat[i-1][j]/2;
					}
					else{
					
					mat[i][slobl]+=mat[i-1][j]/2+1;
					mat[i][slobd]+=mat[i-1][j]/2;}
				}
				else if(mat[i-1][j]%2==0 && slobd!=-1 && slobl!=-1)
				{
					mat[i][slobd]+=mat[i-1][j]/2;
						mat[i][slobl]+=mat[i-1][j]/2;
				}
				
				
				
				
				
				
			}
			
    	}
    	for(int g=1; g<=n; g++)
			{
				if(mat[i][g]>0)
				mat[i][g]--;
						}		
	}
		for(int j=1; j<=n; j++)
		cout<<mat[h][j]<<" ";
		
	
	
	
}